#include <GUIConstantsEx.au3>

#include '_ShellFile.au3'

If @Compiled = 0 Then
	Exit MsgBox($MB_SYSTEMMODAL, '@Compiled Returned 0.', 'Please compile the program before testing. Thanks.')
EndIf

_Main()

Func _Main()
	Local $sFilePath = ''
	If $CmdLine[0] > 0 Then
		$sFilePath = $CmdLine[1]
	EndIf

	Local $hGUI = GUICreate('_ShellFile() Example', 370, 110)
	GUICtrlCreateEdit(_GetFile($sFilePath), 10, 5, 350, 65) ; If a file was passed via commandline then random text will appear in the GUICtrlCreateEdit().

	Local $iAdd = GUICtrlCreateButton('Add FileType', 10, 80, 75, 25)
	Local $iRemove = GUICtrlCreateButton('Remove FileType', 90, 80, 95, 25)

	GUISetState(@SW_SHOW, $hGUI)

	While 1
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE
				ExitLoop

			Case $iAdd
				_ShellFile_Install('Open with _ShellFile()', 'autoit') ; Add the running EXE to the Shell ContextMenu.
				If @error Then
					MsgBox($MB_SYSTEMMODAL, 'Association NOT Created.', '".autoit" was not associated due to an error occurring.')
				Else
					MsgBox($MB_SYSTEMMODAL, 'Association Created.', '"RandomFile.autoit" file was created to show that the filetype ".autoit" has been associtated with ' & @ScriptName & '.' & _
							@CRLF & @CRLF & 'If you restart the computer you''ll see the icon of "RandomFile.autoit" is the same as the program icon.' & _
							@CRLF & @CRLF & 'Now close the program and double/right click on "RandomFile.autoit" to display the random text in the edit box.')
				EndIf
				_SetFile(_RandomText(5000), @ScriptDir & '\RandomFile.autoit', 1) ; Create a file with Random text.

			Case $iRemove
				_ShellFile_Uninstall('autoit') ; Remove the running EXE from the Shell ContextMenu.
				If @error Then
					MsgBox($MB_SYSTEMMODAL, 'Association NOT Deleted.', '".autoit" was not deleted from the Registry due to an error occurring.')
				Else
					MsgBox($MB_SYSTEMMODAL, 'Association Deleted.', '".autoit" was successfully deleted from the Registry and is no longer associated with ' & @ScriptName & '.')
				EndIf

		EndSwitch
	WEnd
	GUIDelete($hGUI)
EndFunc   ;==>_Main

Func _GetFile($sFilePath, $sFormat = 0)
	Local $hFileOpen = FileOpen($sFilePath, $sFormat)
	If $hFileOpen = -1 Then
		Return SetError(1, 0, 'No File Was Passed Via Commandline.')
	EndIf
	Local $sData = FileRead($hFileOpen)
	FileClose($hFileOpen)
	Return $sData
EndFunc   ;==>_GetFile

Func _RandomText($iLength = 7)
	Local $iCount = 0, $iCRLF, $sData = '', $sRandom
	For $i = 1 To $iLength
		$sRandom = Random(55, 116, 1)
		If $iCount = 100 Then
			$iCRLF = @CRLF
			$iCount = 0
		EndIf
		$sData &= Chr($sRandom + 6 * ($sRandom > 90) - 7 * ($sRandom < 65)) & $iCRLF
		$iCount += 1
		$iCRLF = ''
	Next
	Return $sData
EndFunc   ;==>_RandomText

Func _SetFile($sString, $sFilePath, $iOverwrite = 0)
	Local $hFileOpen = FileOpen($sFilePath, $iOverwrite + 1)
	FileWrite($hFileOpen, $sString)
	FileClose($hFileOpen)
	If @error Then
		Return SetError(1, 0, $sString)
	EndIf
	Return $sString
EndFunc   ;==>_SetFile